
#    MIDAS Access Server  for MessageLogger service

global env
source [file join $env(MIDASBASE) TclHttpd tcl MIDASDomainHandler.tcl]       ;#  load default support procedures

global MessageLoggerDirectory

if {[info exists env(MessageLoggerBase)]} then {
    set MessageLoggerDirectory $env(MessageLoggerBase)
} else {
    switch $tcl_platform(platform) {
        windows  {set MessageLoggerDirectory "c:\\midas\\log"}
        unix     {set MessageLoggerDirectory "/MIDAS/log"}
    }
}

global MIDAS_MessageLogger_Verbose
set MIDAS_MessageLogger_Verbose 0

# Use namespaces to isolate your methods
namespace eval urn:MessageLogger {

    proc DefineMessage {class level source message} {
        global MIDAS_MessageLogger_Verbose
        global MessageLoggerDirectory
        if {$MIDAS_MessageLogger_Verbose} {puts "called method MessageLogger with parameters $class $level $source $message"}

        set fileName [file join $MessageLoggerDirectory [clock format [clock seconds] -format "%d%b%y"]]
        set TimeStamp [clock format [clock seconds] -format "%H:%M:%S"]

        set message [format "%8s %2d %1d %-16s %s" $TimeStamp $class $level $source $message]
        
        set z [catch {open $fileName a} file]
        if {$z != 0} then {return -code error -errorcode "$file" -errorinfo "Error detected in open"}
        puts $file "$message"
        close $file

        return [rpcvar::rpcvar int 0]
    }

    # We have to publish the public methods...

     SOAP::export DefineMessage
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /MessageLogger -namespace urn:MessageLogger -uri urn:MessageLogger]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/MessageLogger {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

